#include <windows.h>
#include <stdio.h>


typedef enum { ARG_hFileMap, ARG_hInEvent, ARG_hOutEvent, ARGCOUNT };


typedef enum SLAVEMSG {
	SLAVEMSG_Quit,
	SLAVEMSG_PrintStringW,
} SLAVEMSG, *LPSLAVEMSG;

#pragma pack(4)
typedef struct SLAVEMSGDATA {
	SLAVEMSG	msg;
	HRESULT		hr;
	DWORD		dwInOffset;
	DWORD		dwInSize;
	DWORD		dwInUsed;
	DWORD		dwOutOffset;
	DWORD		dwOutSize;
	DWORD		dwOutUsed;
	BYTE		data[1];
} SLAVEMSGDATA, *LPSLAVEMSGDATA;
#pragma pack()


/// *** SUPPORT MACROS *** ///
/// /D "AXL_TRACE" to enable tracing

#define NOTHING 0

#ifdef UNICODE
#	define stprintf		swprintf
#	define tprintf		wprintf
#	define TRACESTRA	L"S"
#	define TRACESTRW	L"s"
#else /// UNICODE
#	define stprintf		sprintf
#	define tprintf		printf
#	define TRACESTRA	"s"
#	define TRACESTRW	"S"
#endif /// UNICODE
#define TRACEHR_STR		TEXT("0x%08lX (%lu/%lu)")
#define TRACEHR_REF(hr)	(hr),HRESULT_FACILITY(hr),HRESULT_CODE(hr)

#define EXITONHRESULT(x) { hr = (x); goto exit; }
#define EXITONLASTHRESULT() { hr = ((HRESULT) ((GetLastError() & 0x0000FFFF) | (FACILITY_WIN32 << 16) | 0x80000000)); goto exit; }
#define EXITONLASTERROR() { z = FALSE; err = GetLastError(); goto exit; }

#ifdef AXL_TRACE
#	define TRACE(x) x
#	define trace_open(x,y)
#	define trace_close()
#	ifdef UNICODE
#		define trace wprintf
#	else /// UNICODE
#		define trace printf
#	endif /// UNICODE
#else /// AXL_TRACE
#	define TRACE(x)
#endif /// AXL_TRACE

