#include "common.h"


int main(int argc, char* argv[])
{
	HRESULT			hr			= S_OK;
	HANDLE			hFileMap	= NULL;
	HANDLE			hInEvent	= NULL;
	HANDLE			hOutEvent	= NULL;
	LPSLAVEMSGDATA	lpMsg		= NULL;
	BOOL			zExec		= TRUE;

	TRACE(trace_open(NULL,zTrue));

	TRACE(trace(TEXT(">>> [SLAVE ] argv[ARG_hFileMap]  = \"%") TRACESTRA TEXT("\"\n"),argv[ARG_hFileMap]));
	if(NULL == (hFileMap = (HANDLE)strtoul(argv[ARG_hFileMap],NULL,16))) EXITONHRESULT(E_HANDLE);
	TRACE(trace(TEXT(">>> [SLAVE ] hFileMap .......... =  0x%08lX\n"),hFileMap));

	TRACE(trace(TEXT(">>> [SLAVE ] argv[ARG_hInEvent]  = \"%") TRACESTRA TEXT("\"\n"),argv[ARG_hInEvent]));
	if(NULL == (hInEvent = (HANDLE)strtoul(argv[ARG_hInEvent],NULL,16))) EXITONHRESULT(E_HANDLE);
	TRACE(trace(TEXT(">>> [SLAVE ] hInEvent .......... =  0x%08lX\n"),hInEvent));

	TRACE(trace(TEXT(">>> [SLAVE ] argv[ARG_hOutEvent] = \"%") TRACESTRA TEXT("\"\n"),argv[ARG_hOutEvent]));
	if(NULL == (hOutEvent = (HANDLE)strtoul(argv[ARG_hOutEvent],NULL,16))) EXITONHRESULT(E_HANDLE);
	TRACE(trace(TEXT(">>> [SLAVE ] hOutEvent ......... =  0x%08lX\n"),hOutEvent));

	TRACE(trace(TEXT("*** [SLAVE ] MapViewOfFile()...\n")));
	if(NULL == (lpMsg = (LPSLAVEMSGDATA)MapViewOfFile(hFileMap,FILE_MAP_WRITE,0,0,0))) EXITONLASTHRESULT();
	TRACE(trace(TEXT(">>> [SLAVE ] lpMsg ............. =  0x%08lX\n"),lpMsg));

	while(zExec) {
		TRACE(trace(TEXT("*** [SLAVE ] WaitForSingleObject(hInEvent)...\n")));
		if(WAIT_FAILED == WaitForSingleObject(hInEvent,INFINITE)) EXITONLASTHRESULT();
		switch(lpMsg->msg)
		{
			case SLAVEMSG_Quit: {
				TRACE(trace(TEXT("*** [SLAVE ] lpMsg->msg = SLAVEMSG_Quit\n")));
				zExec = FALSE;
				lpMsg->hr = S_OK;
				lpMsg->dwInUsed = 0;
				lpMsg->dwOutUsed = 0;
			} break;
			case SLAVEMSG_PrintStringW: {
				LPWSTR s = (LPWSTR)&lpMsg->data[lpMsg->dwInOffset];
				TRACE(trace(TEXT("*** [SLAVE ] lpMsg->msg = SLAVEMSG_PrintStringW\n")));
				tprintf(TEXT(">>> [SLAVE ] L\"%") TRACESTRW TEXT("\"\n"),s);
				lpMsg->hr = S_OK;
				lpMsg->dwInUsed = sizeof(*s) * (1 + wcslen(s));
				lpMsg->dwOutUsed = 0;
			} break;
			default: {
				TRACE(trace(TEXT("*** [SLAVE ] lpMsg->msg = %d\n"),lpMsg->msg));
				lpMsg->hr = E_NOTIMPL;
				lpMsg->dwInUsed = 0;
				lpMsg->dwOutUsed = 0;
			} break;
		}
		TRACE(trace(TEXT("*** [SLAVE ] SetEvent(hOutEvent)...\n")));
		if(!SetEvent(hOutEvent)) EXITONLASTHRESULT();
	}

exit:
	TRACE(trace(TEXT(">>> [SLAVE ] hr = ") TRACEHR_STR TEXT("\n"),TRACEHR_REF(hr)));
	if(lpMsg) (void)UnmapViewOfFile(lpMsg);
	TRACE(trace_close());
	return hr;
}

